package com.maroontress.coverture;

import com.maroontress.gcovparser.AbstractBlock;
import com.maroontress.gcovparser.LineEntry;
import java.io.PrintWriter;
import java.util.ArrayList;

/**
   ؿդΥΡɤȤʤܥ֥åμ饹Ǥ
*/
public final class Block extends AbstractBlock<Block, Arc> {

    /** ѡȤѴ뤿ηǤ */
    private static final double PERCENT = 100;

    /**
       ֥åޤ

       @param id ֥åμ̻
       @param flags ֥åΥե饰
    */
    public Block(final int id, final int flags) {
	super(id, flags);
    }

    /**
       ֹμ¹Բ򥽡ꥹȤ˥ޡޤ

       ˼¹ԲΥȤͭˤʤäƤɬפޤ

       @param sourceList ꥹ
    */
    public void addLineCounts(final SourceList sourceList) {
	assert (getCount() >= 0);
	long count = getCount();
	LineEntry[] lines = getLines();
	if (lines == null) {
	    return;
	}
	// forLineEntry˰ܤ...
	// e.addLineCounts(sourcelist, count);
	for (LineEntry e : lines) {
	    String fileName = e.getFileName();
	    int[] nums = e.getLines();
	    if (nums.length == 0) {
		continue;
	    }
	    Source source = sourceList.getSource(fileName);
	    for (int k = 0; k < nums.length; ++k) {
		source.addLineCount(nums[k], count);
	    }
	}
    }

    /**
       ¹Գʥѡȡˤޤ

       @param c ¹Բ
       @return ¹Գ
    */
    private double getRate(final long c) {
	long count = getCount();
	return (count == 0) ? 0 : PERCENT * c / count;
    }

    /**
       XMLǥ֥åϤޤ

       @param out 
    */
    public void printXML(final PrintWriter out) {
	final boolean countValid = getCountValid();

	out.printf("<block id='%d' flags='0x%x' callSite='%b' "
		   + "callReturn='%b' nonLocalReturn='%b'",
		   getId(), getFlags(), isCallSite(),
		   isCallReturn(), isNonLocalReturn());
	if (countValid) {
	    out.printf(" count='%d'", getCount());
	}
	out.printf(">\n");

	ArrayList<Arc> outArcs = getOutArcs();
	for (Arc arc : outArcs) {
	    out.printf("<arc destination='%d' fake='%b' onTree='%b' "
		       + "fallThrough='%b' callNonReturn='%b' "
		       + "nonLocalReturn='%b' unconditional='%b'",
		       arc.getEnd().getId(), arc.isFake(), arc.isOnTree(),
		       arc.isFallThrough(), arc.isCallNonReturn(),
		       arc.isNonLocalReturn(), arc.isUnconditional());
	    if (countValid) {
		long c = arc.getCount();
		out.printf(" count='%d' rate='%.2f'", c, getRate(c));
	    }
	    out.printf("/>\n");
	}
	LineEntry[] lines = getLines();
	if (lines != null) {
	    // forLineEntry˰ܤ...
	    // e.printXML();
	    for (LineEntry e : lines) {
		String fileName = e.getFileName();
		int[] nums = e.getLines();
		if (nums.length == 0) {
		    continue;
		}
		out.printf("<lines fileName='%s'>\n", XML.escape(fileName));
		for (int k = 0; k < nums.length; ++k) {
		    out.printf("<line number='%d' />\n", nums[k]);
		}
		out.printf("</lines>\n");
	    }
	}
	out.printf("</block>\n");
    }
}
