package com.maroontress.coverture;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.Reader;
import java.io.Writer;
import java.nio.charset.Charset;

/**
   Ϥ˴ϢץѥƥǤ
*/
public final class IOProperties {

    /** ¿ΥåϤ뤫ɤΥե饰Ǥ */
    private boolean verbose;

    /** եϤǥ쥯ȥǤ */
    private File outputDir;

    /** եʸǤ */
    private Charset sourceFileCharset;

    /** gcovեʸǤ */
    private Charset gcovFileCharset;

    /** gcovեϤ뤫ɤΥե饰Ǥ */
    private boolean gcovEnabled;

    /**
       ǥեȤϥץѥƥޤ
    */
    public IOProperties() {
	verbose = false;
	outputDir = new File(".");
	sourceFileCharset = Charset.defaultCharset();
	gcovFileCharset = Charset.defaultCharset();
	gcovEnabled = false;
    }

    /**
       gcovեϤ뤫ɤꤷޤ

       @param b gcovեϤtrue
    */
    public void setGcovEnabled(final boolean b) {
	gcovEnabled = b;
    }

    /**
       gcovեϤ뤫ɤޤ

       @return gcovեϤtrue
    */
    public boolean isGcovEnabled() {
	return gcovEnabled;
    }

    /**
       åϤĹˤ뤫ɤꤷޤ

       @param b åϤĹˤtrueϡǤʤ
       false
    */
    public void setVerbose(final boolean b) {
	verbose = b;
    }

    /**
       եϤǥ쥯ȥꤷޤ

       @param dir եϤǥ쥯ȥ
    */
    public void setOutputDir(final File dir) {
	outputDir = dir;
    }

    /**
       եʸꤷޤ

       @param cs եʸ
    */
    public void setSourceFileCharset(final Charset cs) {
	sourceFileCharset = cs;
    }

    /**
       gcovեʸꤷޤ

       @param cs gcovեʸ
    */
    public void setGcovFileCharset(final Charset cs) {
	gcovFileCharset = cs;
    }

    /**
       åϤĹˤ뤫ɤޤ

       @return åϤĹˤtrueϡǤʤ
       false
    */
    public boolean isVerbose() {
	return verbose;
    }

    /**
       ϥեޤ

       @param path ϥǥ쥯ȥȤХѥ
       @return ϥե
    */
    public File createOutputFile(final String path) {
	return new File(outputDir, path);
    }

    /**
       Υǥ쥯ȥޤ
    */
    public void makeOutputDir() {
	outputDir.mkdirs();
    }

    /**
       gcovեΥ饤ޤ

       @param path ϥǥ쥯ȥȤХѥ
       @return gcovեΥ饤
       @throws FileNotFoundException եǤʤ
    */
    public Writer createGcovWriter(final String path)
	throws FileNotFoundException {
	File file = createOutputFile(path);
	Writer out = new OutputStreamWriter(new FileOutputStream(file),
					    gcovFileCharset);
	return out;
    }

    /**
       եΥ꡼ޤ

       @param file ե
       @return եΥ꡼
       @throws FileNotFoundException ե뤬¸ߤʤ
    */
    public Reader createSourceFileReader(final File file)
	throws FileNotFoundException {
	Reader in = new InputStreamReader(new FileInputStream(file),
					  sourceFileCharset);
	return in;
    }
}
