package com.maroontress.cui;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;
import java.util.TreeMap;

/**
   ޥɥ饤󥪥ץǤ
*/
public final class Options {
    /** إץåΥǥκǾͤǤ */
    private static final int MIN_INDENT_WIDTH = 4;

    /** ʤΥץΥåȤǤ */
    private Set<String> options;

    /** ΥץΥåȤǤ */
    private Set<String> argOptions;

    /**
       ޥɥ饤󥪥ץ̾ȰͤΥޥåפǤʤ
       ΥץǤϡͤnullˤʤޤ
    */
    private Map<String, String> valueMap;

    /** ץȤ˸ƤӽФꥹʤΥޥåפǤ */
    private Map<String, OptionListener> listenerMap;

    /** ץΥإץåΥޥåפǤ */
    private Map<String, String> helpMap;

    /**
       ޥɥ饤󥪥ץޤ
    */
    public Options() {
	options = new HashSet<String>();
	argOptions = new HashSet<String>();
	valueMap = new HashMap<String, String>();
	listenerMap = new HashMap<String, OptionListener>();
	helpMap = new TreeMap<String, String>();
    }

    /**
       إץåΥޥåפޤޥåפΥϥץ
       ̾ͤϥإץåˤʤޤΥץǤϡ
       ץ̾ϡ̾=̾פˤʤޤ

       @return إץåΥޥå
    */
    public Map<String, String> getHelpMap() {
	return helpMap;
    }

    /**
       ʤΥץɲäޤ

       @param name ץ̾
       @param listener ץꥹ
       @param help إץå
    */
    public void add(final String name,
		    final OptionListener listener,
		    final String help) {
	listenerMap.put(name, listener);
	add(name, help);
    }

    /**
       ʤΥץɲäޤ

       @param name ץ̾
       @param help إץå
    */
    public void add(final String name,
		    final String help) {
	options.add(name);
	helpMap.put(name, help);
    }

    /**
       Υץɲäޤ

       @param name ץ̾
       @param listener ץꥹ
       @param argName ̾
       @param help إץå
    */
    public void add(final String name,
		    final OptionListener listener,
		    final String argName,
		    final String help) {
	listenerMap.put(name, listener);
	add(name, argName, help);
    }

    /**
       Υץɲäޤ

       @param name ץ̾
       @param argName ̾
       @param help إץå
    */
    public void add(final String name,
		    final String argName,
		    final String help) {
	argOptions.add(name);
	helpMap.put(name + "=" + argName, help);
    }

    /**
       ʸ󤬥ץ󤫤ɤޤ

       @param s ʸ
       @return sץξtrue
    */
    private boolean isOption(final String s) {
	return s.startsWith("--");
    }

    /**
       ץѡޤ

       @param s ץ
       @throws OptionsParsingException ץΥѡ˼Ԥ
       ˥ޤ
    */
    private void parseOption(final String s) throws OptionsParsingException {
	String argName;
	String argValue;
	Set<String> set;
	int n = s.indexOf('=');
	if (n < 0) {
	    argName = s.substring(2);
	    argValue = null;
	    set = options;
	} else {
	    argName = s.substring(2, n);
	    argValue = s.substring(n + 1);
	    set = argOptions;
	}
	if (!set.contains(argName)) {
	    throw new OptionsParsingException("invalid option: " + s);
	}
	OptionListener listener = listenerMap.get(argName);
	if (listener != null) {
	    listener.run(argName, argValue);
	}
	valueMap.put(argName, argValue);
    }

    /**
       ޥɥ饤ΰѡޤ

       --ǻϤޤ򥪥ץȤƲᤷޤʳΰ
       ʳǥѡλޤ

       @param av ޥɥ饤ΰ
       @return ޥɥ饤ΰΤǽ˽и󥪥ץ
       ΰǸΰޤǤ
       @throws OptionsParsingException ʥץλ
    */
    public String[] parseFore(final String[] av)
	throws OptionsParsingException {
	String s;
	int k;

	for (k = 0; k < av.length && isOption(s = av[k]); ++k) {
	    parseOption(s);
	}
	return Arrays.copyOfRange(av, k, av.length);
    }

    /**
       ޥɥ饤ΰѡޤ

       --ǻϤޤ򥪥ץȤƲᤷޤʳΰϥ
       ץȤƲ᤻åפޤ

       @param av ޥɥ饤ΰ
       @return ץǤϤʤ
       @throws OptionsParsingException ʥץλ
    */
    public String[] parse(final String[] av) throws OptionsParsingException {
	ArrayList<String> args = new ArrayList<String>();

	for (String s : av) {
	    if (!isOption(s)) {
		args.add(s);
		continue;
	    }
	    parseOption(s);
	}
	return args.toArray(new String[args.size()]);
    }

    /**
       ץΰͤޤץѡ˸
       ӽФɬפޤ

       ץ󤬻ꤵʤʤΥץξϡnull
       ֤ޤ

       @param name ץ̾
       @return ץ͡ޤnull
    */
    public String getValue(final String name) {
	return valueMap.get(name);
    }

    /**
       ץλ̵ͭޤץѡ
       ƤӽФɬפޤ

       @param name ץ̾
       @return ץ󤬻ꤵƤtrueǤʤfalse
    */
    public boolean specified(final String name) {
	return valueMap.containsKey(name);
    }

    /**
       ץޤ

       @param indentWidth ץΥǥ
       @return 
    */
    public String getHelpMessage(final int indentWidth) {
	int width = Math.max(MIN_INDENT_WIDTH, indentWidth);
	String helpIndent = "\n";
	for (int k = 0; k < width; ++k) {
	    helpIndent += " ";
	}
	Set<Map.Entry<String, String>> set = helpMap.entrySet();
	String format = "--%-" + (width - MIN_INDENT_WIDTH) + "s  %s\n";
	String m = "";
	for (Map.Entry<String, String> e : set) {
	    String desc = e.getValue().replace("\n", helpIndent);
	    m += String.format(format, e.getKey(), desc);
	}
	return m;
    }
}
